import 'package:flutter/material.dart';
import 'package:test_sa/extensions/context_extension.dart';
import 'package:test_sa/extensions/int_extensions.dart';
import 'package:test_sa/extensions/text_extensions.dart';
import 'package:test_sa/extensions/widget_extensions.dart';
import 'package:test_sa/new_views/app_style/app_color.dart';

class ADatePicker extends StatelessWidget {
  final DateTime date;
  final DateTime from;
  final DateTime to;
  final String label;
  final Function(DateTime) onDatePicker;
  final bool enable, withBorder;
  final Color backgroundColor;

  const ADatePicker({
    Key key,
    @required this.label,
    this.withBorder = true,
    this.backgroundColor,
    this.date,
    this.onDatePicker,
    this.from,
    this.to,
    this.enable = true,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      decoration: BoxDecoration(
        color: backgroundColor ??
            (context.isDark && (enable == false)
                ? AppColor.neutral50
                : (enable == false)
                    ? AppColor.neutral40
                    : AppColor.background(context)),
        borderRadius: BorderRadius.circular(10),
        border: withBorder ? Border.all(width: 1, color: Theme.of(context).scaffoldBackgroundColor) : const Border(),
        boxShadow: [BoxShadow(color: Colors.black.withOpacity(0.05), blurRadius: 10)],
      ),
      padding: EdgeInsets.symmetric(horizontal: 16.toScreenWidth, vertical: 8.toScreenHeight),
      child: Row(
        children: [
          enable
              ? Column(
                  crossAxisAlignment: CrossAxisAlignment.stretch,
                  mainAxisSize: MainAxisSize.min,
                  children: [
                    label.tinyFont(context),
                    ((date?.toIso8601String()?.split("T")?.first) ?? context.translation.pickADate).bodyText(context).custom(color: context.isDark ? AppColor.neutral30 : AppColor.neutral50),
                  ],
                ).expanded
              : label.bodyText(context).paddingOnly(top: 8, bottom: 8),
          enable ? 16.width : const Spacer(),
          "calender".toSvgAsset(width: 20, color: context.isDark ? AppColor.neutral10 : null),
        ],
      ),
    ).onPress(enable
        ? () async {
            DateTime picked = await showDatePicker(
              context: context,
              initialDate: DateTime.now(),
              firstDate: from ?? DateTime.now(),
              lastDate: to ?? DateTime.now().add(const Duration(days: 365)),
            );
            if (onDatePicker != null) onDatePicker(picked);
          }
        : null);
  }
}
